%define name warewulf
%define version 2.4.2
%define release 1mdk

Name: %name
Summary: A cluster implementation and management tool
Version: %version
Release: %release
License: GPL
Group: System/Servers
URL: http://warewulf.lbl.gov/
Source: %{name}-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
Requires: dhcp tftp-server nfs-utils perl rsh
Requires: %{name}-tools = %{version}
ExclusiveOS: linux
BuildRequires: glibc-static-devel

%description
Warewulf is a customizable tool that facilitates the building and
administration of computer clusters. Updating a cluster configuration
in Warewulf is easy because it uses RAM disks as the primary media for
storing the node OS image.

This package constitutes the main component of the Warewulf system. It
contains the monitoring, configuration, and node build tools, and
should be installed on the cluster boot server (master).

%package tools
Summary: The Warewulf user tools
Group: System/Configuration/Other
Requires: perl-Term-Screen >= 1.02

%description tools
Warewulf is a customizable tool that facilitates the building and
administration of computer clusters. Updating a cluster configuration
in Warewulf is easy because it uses RAM disks as the primary media for
storing the node OS image.

This package contains the Warewulf user tools. It has been separated
from the main Warewulf package to allow for the configuration of
multiple interactive login nodes and remote monitoring nodes.

%package wulfd
Summary: The Warewulf node daemon
Group: System/Servers
Prereq: chkconfig

%description wulfd
Warewulf is a customizable tool that facilitates the building and
administration of computer clusters. Updating a cluster configuration
in Warewulf is easy because it uses RAM disks as the primary media for
storing the node OS image.

This package contains the node daemon component of the Warewulf system. 

%prep
%setup -n %{name}-%{version} 
%build
%{__make} %{?mflags}

%install
%{__make} install DESTDIR=%{buildroot} %{?mflags_install}

%{__mkdir_p} %{buildroot}/var/warewulf/vnfs
%{__mkdir_p} %{buildroot}/srv/vnfs

echo "Warewulf release %{version}-%{release}" > \
   %{buildroot}/etc/warewulf-release

%post
/sbin/chkconfig --add warewulfd
/sbin/chkconfig warewulfd on
/sbin/service warewulfd restart >/dev/null 2>&1
/sbin/chkconfig --add vnfsd
/sbin/chkconfig vnfsd on
/sbin/service vnfsd restart >/dev/null 2>&1
/usr/sbin/wwmkinitrd >&2

%post wulfd
chkconfig --add wulfd
chkconfig wulfd on

%preun
if [ $1 -eq '0' ]; then
   /etc/rc.d/init.d/warewulfd stop >/dev/null 2>&1
   chkconfig --del warewulfd
   /etc/rc.d/init.d/vnfsd stop >/dev/null 2>&1
   chkconfig --del vnfsd
fi

%preun wulfd
if [ $1 -eq '0' ]; then
   /etc/rc.d/init.d/wulfd stop >/dev/null 2>&1
   chkconfig --del wulfd
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc Readme Copyright Credits Install License Todo ChangeLog extras
%config() %{_sysconfdir}/warewulf-release
%config(noreplace) %{_sysconfdir}/warewulf/wwinitrd.config
%config(noreplace) %{_sysconfdir}/warewulf/master.conf
%config(noreplace) %{_sysconfdir}/warewulf/nodes.conf
%config(noreplace) %{_sysconfdir}/warewulf/vnfs/*
%config /usr/lib/warewulf/wwinitrc
%dir /srv/vnfs
%dir /var/warewulf
%dir /var/warewulf/vnfs
%dir /var/warewulf/syncs
%{_sysconfdir}/rc.d/init.d/warewulfd
%{_sysconfdir}/rc.d/init.d/vnfsd
/usr/lib/warewulf/Warewulf.pm
/usr/lib/warewulf/modules/*
%{_sbindir}/warewulfd
%{_sbindir}/vnfsd
%{_sbindir}/wwmkinitrd
%{_sbindir}/wwnodes
%{_sbindir}/wwvnfs
%{_sbindir}/wwinit
%{_sbindir}/wwdebug
%{_bindir}/wwps
/var/warewulf/wwinitrd
%{_mandir}/man8/wwinit.8.*
%{_mandir}/man8/wwnodes.8.*
%{_mandir}/man8/wwvnfs.8.*
%{_mandir}/man8/wwmkinitrd.8.*
%{_mandir}/man5/nodes.conf.5.*
%{_mandir}/man5/master.conf.5.*

%files tools
%defattr(-,root,root)
%doc Readme Copyright Credits Install License Todo ChangeLog
%config(noreplace) %{_sysconfdir}/warewulf/client.conf
/usr/lib/warewulf/Warewulf.pm
/usr/lib/warewulf/logo.xpm
%{_bindir}/wwlist
%{_bindir}/wwstats
%{_bindir}/wwsummary
%{_bindir}/wwtop
%{_mandir}/man8/wwlist.8.*
%{_mandir}/man8/wwstats.8.*
%{_mandir}/man8/wwtop.8.*

%files wulfd
%defattr(-,root,root)
%doc Readme Copyright Credits Install License Todo ChangeLog
%config() %{_sysconfdir}/sysconfig/wulfd
%{_sysconfdir}/rc.d/init.d/wulfd
%{_sbindir}/wulfd

%changelog
* Thu Jun 30 2005 Lev Givon <lev@columbia.edu> 2.4.2-1mdk
- Updated to 2.4.2.

* Mon May 30 2005 Lev Givon <lev@columbia.edu> 2.4.1-1mdk
- Updated spec file for Mandrake.  

* Thu Aug 26 2004 Tim Mattox <tmattox@gmail.com>
- Supplied a default node hosts template file that only has localhost
- Reverted yesterday's change in hostname/alias order so that the master's
  default hostname is again listed first.  The real workaround for the
  experienced bug is to not list the master's non-cluster IP addresses in
  the master's and nodes' /etc/hosts files.
- Added a check and warning to wwmaster.hosts for the above.

* Wed Aug 25 2004 Tim Mattox <tmattox@gmail.com>
- Restructured the code in wwnode.sync to fix an obscure /etc/group bug
  This should also clean up some other pathological group and passwd cases.
  Unfortunately to fix the obscure bug, it needed an extensive code change.
- wwnode.sync will now support different /etc/hosts templates per vnfs as
  it was intended to do when that feature was added in 2.2.0.
- changed the --synctree option of wwnode.sync to --norsync to better match
  what it actually does.  Note: the old option still works for now.
- modified Warewulf.pm to add the master's default hostname to the end of the
  list of hostname aliases when generating /etc/hosts entries for the
  master and the nodes.  This works around a "bug/misfeature" of both
  the rlogind & rshd reporting "Host address mismatch" in some situations
  where the master/node has more than one IP address and has hostname aliases.
- wwnode.sync now includes all the variations on the hostnames in hosts.equiv
- wwvnfs.build does a "too small" check to look for a failed wwvnfs.install
- squashed another ramdisk size calculation bug in wwvnfs.build
- wmaster.initiate warns if master's hostname resolves to 127.0.0.1
- Released 2.2.3

* Tue Aug 24 2004 Tim Mattox <tmattox@gmail.com>
- Added support for an optional "gateway = " parameter in nodes.conf
  If it's left blank or not assigned, the node's gateway will be set to
  the IP address of the master's default network device, which is the
  same behaviour before adding this option.

* Mon Aug 23 2004 Tim Mattox <tmattox@gmail.com>
- Added "skip" parameter to nodes in nodes.conf, so you can put in a
  placeholder for an unused nodename.  Warewulf will not see or talk
  about a skipped node, however, it will consume a nodeid, and thus the
  corresponding IP address will not be assigned by warewulf.  A node
  entry with a parameter "skip = 1" does not need any other field assigned.
  This is useful for long term "dead" nodes, or for those who don't want
  a node0000.

* Sun Aug 22 2004 Tim Mattox <tmattox@gmail.com>
- Changed warewulf-node to not own /etc/issue, but to only symlink it to
  /etc/issue-warewulf if it didn't exist.  Hopefully this will work with FC.
- Added "-b 1024" to the mke2fs call in make_img in wwvnfs.build.  The
  initrd code in the kernel only supports that blocksize.  This makes it
  possible to have the initrd be larger than 512 MB.
- Added optional vnfs.conf parameter "modules path prefix" to change where
  the modules are copied from when wwvnfs.build makes the ramdisk.
- Made wwvnfs.build work with 2.6 kernel's .ko module files.
- Fixed a close() call in wwnode.sync  (/etc/group stuff still needs work.)

* Tue Aug 17 2004 Tim Mattox <tmattox@gmail.com>
- Added a sanity check for 'default network' to wwmaster.initiate
- Added a message to ignore the warning about first32pm, and tweaked the
  call to mknbi-linux in wwvnfs.build to eliminate a UTF-8 warning
  (the first32pm option is still needed for older mknbi versions)
- Added 'async' to the NFS exports options created by wwmaster.exports.
  This removes a warning about NFS changing which was the default behaviour.
  If you need sync (or other NFS export options), edit the wwmaster.exports
  script, or supply a patch that makes it a config option for everyone...
- Added an optional yum.conf parameter to vnfs.conf so that wwvnfs.install
  can be set to use a different yum.conf file from the master.  This allows
  for the master to be a different distro, arch, etc. than the nodes.
- Added warning to wwvnfs.build about needing to rerun wwmaster.dhcpd if
  any nodes are using PXELINUX.  Also, moved the invocation of wwmaster.dhcpd
  in wwmaster.initiate to the end, so it comes after wwvnfs.build
- Added a check to wwmaster.dhcpd for existence of the pxelinux.cfg template(s)
- Simplified/improved the prompt text in wwmaster.initiate
- Reverted the name of the specfile to not include the version number.
- Released 2.2.2

* Thu Aug 12 2004 Tim Mattox <tmattox@gmail.com>
- Added a Provides: kernel line to the warewulf-node RPM to try and prevent
  yum from pulling in a kernel package into the VNFS where it causes problems.

* Wed Aug 11 2004 Tim Mattox <tmattox@gmail.com>
- Fixed the generation-of/appending-to master's and nodes' /etc/hosts file
  and made the default template be the master's /etc/hosts
- Released 2.2.1

* Fri Jul 30 2004 Tim Mattox <tmattox@gmail.com>
- Tweaked the excludes & exclude-nfs files for CentOS 3.1 and x86_64
- wwvnfs.build now explicetly ignores the VNFS's /lib/modules, since
  modules are taken from the master's /lib/modules/
  These two reduced the ramdisk size from about 60 MB to 30 MB on CentOS.
- Released 2.2.0

* Thu Jul 29 2004 Tim Mattox <tmattox@gmail.com>
- Removed size=30% parameter of the tmpfs mount in the node's linuxrc since
  "older" kernel versions still in use didn't support the percent notation.

* Wed Jul 28 2004 Tim Mattox <tmattox@gmail.com>
- Added support for using PXELINUX (version >= 2.05) instead of Etherboot.  
  To use PXELINUX, put a copy of pxelinux.0 from kernel.org into /tftpboot,
  Then edit nodes.conf to set pxeboot = pxelinux.0 in the [defaults] section
  or for individual nodes.
- Added support for an alternative boot MAC address to support boot NICs
  that retain a custom MAC address across warm boots.  It's the same node,
  but dhcpd needs to have the two sets of MAC address info.  FNNs will
  experience this.  To use, just add "hardware addr2 = XYZ" to each node
  entry in node.conf, replaceing the XYZ with the node's custom MAC address.
- Adjusted excludes-nfs so that more cron stuff is on the ramdisk and not NFS
- Added FNN related stuff to master-includes to make FNN support simpler.

* Wed Jun 29 2004 Tim Mattox <tmattox@gmail.com>
- Updated my e-mail address
- Added a linuxrc script to copy the ramdisk to a tmpfs root when a node boots
  This removes the need for seperate tmpfs /tmp and /var/tmp, as well as
  makes it less critical to accurately size the original ramdisk.
  The contents of the tmpfs are also swapable if the node has swap.
- The node's gateway is the master's IP on the default network, rather than
  force it to be on the admin network.
- Added libstdc++ to vnfs.conf "include packages", for better LAM support
- Added support for "disable virtual terminals" option in vnfs.conf
- made warewulf-init append to network config files rather than truncate
  them, which helps for FNN support.

* Wed Jun 15 2004 Greg Kurtzer <GMKurtzer@lbl.gov>
- Added support for defining a specific interface's IP address
- Added support for 'other net's in nodes.conf and wwmaster.dhcp
- Abstracted out the hosts file for people that need customization

* Wed Apr 14 2004 Greg Kurtzer <GMKurtzer@lbl.gov>
- Made slight modifications to enable SGE
- Added wwmaster.info tool

* Wed Apr  7 2004 Greg Kurtzer <GMKurtzer@lbl.gov>
- Released 2.1

* Wed Apr  7 2004 Tim Mattox <tmattox@gmail.com>
- You can now use the = symbol in the vnfs.conf 'kernel args' parameter
- Upped the extra number of inodes for the hybrid ramdisk/NFS, and made
  the warning condition about 'few free inodes' be more loose.
- Added more default entries for /usr/share in the symlinks-nfs file based on
  a cAos-1 system... Running out of inodes on the ramdisk is annoying ;-)

* Mon Apr  5 2004 Tim Mattox <tmattox@gmail.com>
- Fixed a few bugs with the split out of warewulfd and wulfd init scripts
- Updated docs/CHANGELOG & docs/INSTALL files for the upcoming 2.1 release
- Fixed several help messages in the ww* commands to match their new names
- Added support for 'wulfd options' to wwvnfs.build and init.d/wulfd

* Mon Apr  5 2004 Greg Kurtzer <GMKurtzer@lbl.gov>
- Split out the warewulfd and wulfd init scripts
- Changed the default node names for admin, cluster and sharedfs to
  node0000-admin, node0000-clust, and node0000-sfs

* Thu Apr  2 2004 Greg Kurtzer <GMKurtzer@lbl.gov>
- Removed the node sysconfig/wulfd file (now created by wwvnfs.build)

* Thu Apr  1 2004 Greg Kurtzer <GMKurtzer@lbl.gov>
- Woops, fixed a bad configuration option in the default config
- Changed the default node names for admin, cluster to node0000-a/c
- Moved the net device configurations from vnfs.conf to nodes.conf
- Added support for Windows cluster management
- Changed the usertools nomenclature to match the sbin nomenclature paradigm

* Mon Mar 29 2004 Tim Mattox <tmattox@gmail.com>
- Fixed a minor bug in wwmaster.exports, now uses 'restart nfs' command
- Increased the feedback from wwmaster.initiate and wwvnfs.install
- wwvnfs.build is now able to disable some virtual terminals in inittab
- wwvnfs.build makes mountpoints for 'vnfs dir' and 'sharedfs dir' if needed
- Fixed a bug in the 'stop' command of /etc/rc.d/init.d/warewulfd 

* Mon Mar 29 2004 Greg Kurtzer <GMKurtzer@lbl.gov>
- Fixed up some minor bugs in the spec file

* Tue Mar 16 2004 Greg Kurtzer <GMKurtzer@lbl.gov>
- Brought up to date with 2.1 development tree
- Made so many fixes I can't remember them all (rewrite of many components)

* Wed Mar 10 2004 Greg Kurtzer <GMKurtzer@lbl.gov>
- Brought up to date with 2.0 development series
- Changed the files prefix to rpm macros

* Sun Nov 16 2003 Greg Kurtzer <GMKurtzer@lbl.gov>
- Added 'Requires:' to node subpackage
- Added 'Prepreq:'s to node subpackage

* Wed Nov  5 2003 Greg Kurtzer <GMKurtzer@lbl.gov>
- Removed the nfskit and isokit subpackages
- Removed Myrinet default mapper.args file

* Thu Oct 30 2003 Greg Kurtzer <GMKurtzer@lbl.gov>
- Removed the VNFS component of the SPEC
- Disabled restartting of services

* Fri Sep 26 2003 Greg Kurtzer <GMKurtzer@lbl.gov>
- Modified the %post node to make sure that warewulf-init and warewulfd are on

* Tue Sep 24 2003 Greg Kurtzer <GMKurtzer@lbl.gov>
- Added config file /etc/warewulf/dhcpd.tpl to %files

* Tue Sep 16 2003 Greg Kurtzer <GMKurtzer@lbl.gov>
- Added the nagios plugin subpacakges to the SPEC

* Mon Aug 11 2003 Greg Kurtzer <GMKurtzer@lbl.gov>
- Corrected dir perms of /var/tmp in the nodefs (thanks to Geoff Galitz)
- Cleaned SPEC so config is not overwritten and service is restartted 
  properly
- Did a large amount of cleaning in the SPEC

* Wed Jul 23 2003 Greg Kurtzer <GMKurtzer@lbl.gov>
- Changed spec to make upgrades even more reliable
- Adjusted spec to reflect node filesystem changes

* Fri Apr 18 2003 Greg Kurtzer <GMKurtzer@lbl.gov>
- Made some basic chages to SPEC to make upgrades more reliable

* Tue Jan 14 2003 Greg Kurtzer <GMKurtzer@lbl.gov>
- Added the node-partition config file in the node's /etc/warewulf/

* Tue Dec 17 2002 Greg Kurtzer <GMKurtzer@lbl.gov>
- Added the Conflicts tag to warewulf-node just in case...
- Got a bit more specific with the bin/* and sbin/* tools for each package
- Fixed some weirdness in the node RPM

* Sun Nov 10 2002 Greg Kurtzer <GMKurtzer@lbl.gov>
- Split Warewulf into 3 packages: warewulf, warewulf-node and warewulf-nodefs

* Sun Sep 29 2002 Greg Kurtzer <GMKurtzer@lbl.gov>
- Build first spec file for Warewulf

